unit uTEST;

// Binuar
// Big integer number arithmetic
// ---
// Copyright  2000-3000, Andrey A. Meshkov (AL-CHEMIST)
// All rights reserved
//
// http://maalchemist.ru
// maa@maalchemist.ru
// maalchemist@yandex.ru
// maalchemist@gmail.com
//
// Free for any use.
// No warranty of any kind.
// ---

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, StdCtrls;

type
  TmForm = class(TForm)
    StatusBar: TStatusBar;
    P_Buttons: TPanel;
    P_LOG: TPanel;
    ED_LOG: TMemo;
    BT_TEST: TButton;
    BT_Clear: TButton;
    procedure FormCreate(Sender: TObject);
    procedure BT_ClearClick(Sender: TObject);
    procedure BT_TESTClick(Sender: TObject);
  end;

var
  mForm: TmForm;

implementation

{$R *.DFM}

uses
  mxBNMathTypes, mxBNMath, mxBNMathUtils, mxBNMathProcs, mxBNMathConv,
  mxBNMathRandom;

{
}
procedure Refresh_(var T: DWORD; AForce: Boolean = false);
begin
  if AForce then begin
    Application.ProcessMessages;
    T := GetTickCount;
    Exit;
  end;

  if GetTickCount - T > 400 then begin
    Application.ProcessMessages;
    T := GetTickCount;
  end;
end;

{
}
procedure TmForm.FormCreate(Sender: TObject);
begin
//
end;

{
}
procedure TmForm.BT_ClearClick(Sender: TObject);
begin
  ED_LOG.Lines.Clear;
end;

{
}
procedure TmForm.BT_TESTClick(Sender: TObject);
var
  T       : DWORD;

  bnx_0   : T_BNX;
  bnx_1   : T_BNX;
  bnx_2   : T_BNX;
  bnx_3   : T_BNX;
  bnx_100 : T_BNX;
  bnx_R   : T_BNX;

  S_1     : string;
  S_2     : string;
  S_R     : string;

  VCursor : TCursor;
begin
  T := GetTickCount;

  VCursor := Screen.Cursor;
  try
    Screen.Cursor := crHourGlass;

    BN_exp2 (bnx_0, 1, 0);
    {$IFDEF CPUX64}
    BN_pshld (bnx_0, 63);
    {$ELSE}
    BN_pshld (bnx_0, 31);
    {$ENDIF}
    BN_shl_1 (bnx_0);

    {$IFDEF CPUX64}
    BN_exp2 (bnx_0, 1, 64);
    BN_pshrd (bnx_0, 63);
    {$ELSE}
    BN_exp2 (bnx_0, 1, 32);
    BN_pshrd (bnx_0, 31);
    {$ENDIF}
    BN_shr_1 (bnx_0);
    BN_shr_1 (bnx_0);

    BN_exp2 (bnx_0, 1, 0);
    BN_inc_(bnx_0);
    BN_dec_(bnx_0);

    BN_exp2 (bnx_0, 1, 0);
    bnx_1.Sign := -1;
    BN_inc_(bnx_0);
    BN_dec_(bnx_0);

    BN_exp2 (bnx_0, 1, 0);
    bnx_1.Sign := -1;
    BN_dec_(bnx_0);
    BN_inc_(bnx_0);

    BN_Free (bnx_0);
    BN_AssignInt (bnx_1, 1, 2);
    BN_AssignInt (bnx_2, 1, 8);
    BN_pow (bnx_0, bnx_1, bnx_2); // 256

    BN_Free (bnx_0);
    BN_AssignInt (bnx_1, -1, 2);
    BN_AssignInt (bnx_2, 1, 9);
    BN_pow_base (bnx_0, bnx_1, bnx_2); // -512

    ED_LOG.Lines.ADD ('###################');
    ED_LOG.Lines.ADD ('##  BN_add TEST  ##');
    ED_LOG.Lines.ADD ('###################');
    // ----
    S_1 := '11111111112222222222333333333344444444445555555555';
    S_2 := '55555555556666666666777777777788888888889999999999';
    // ----
    BN_Base10 (bnx_1, S_1);
    BN_Base10 (bnx_2, S_2);
    BN_add (bnx_R, bnx_1, bnx_2);
    // ----
    S_R := BN_Base10 (bnx_R);
    ED_LOG.Lines.ADD (S_1);
    ED_LOG.Lines.ADD ('+');
    ED_LOG.Lines.ADD (S_2);
    ED_LOG.Lines.ADD ('=');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);

    ED_LOG.Lines.ADD ('###################');
    ED_LOG.Lines.ADD ('##  BN_sub TEST  ##');
    ED_LOG.Lines.ADD ('###################');
    // ----
    S_1 := '11111111112222222222333333333344444444445555555555';
    S_2 := '55555555556666666666777777777788888888889999999999';
    // ----
    BN_Base10 (bnx_1, S_1);
    BN_Base10 (bnx_2, S_2);
    BN_sub (bnx_R, bnx_1, bnx_2);
    // ----
    S_R := BN_Base10 (bnx_R);
    ED_LOG.Lines.ADD (S_1);
    ED_LOG.Lines.ADD ('-');
    ED_LOG.Lines.ADD (S_2);
    ED_LOG.Lines.ADD ('=');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);

    ED_LOG.Lines.ADD ('###################');
    ED_LOG.Lines.ADD ('##  BN_sub TEST  ##');
    ED_LOG.Lines.ADD ('###################');
    // ----
    S_1 := '11111111112222222222333333333344444444445555555555';
    S_2 := '55555555556666666666777777777788888888889999999999';
    // ----
    BN_Base10 (bnx_1, S_1);
    BN_Base10 (bnx_2, S_2);
    BN_sub (bnx_R, bnx_2, bnx_1);
    // ----
    S_R := BN_Base10 (bnx_R);
    ED_LOG.Lines.ADD (S_2);
    ED_LOG.Lines.ADD ('-');
    ED_LOG.Lines.ADD (S_1);
    ED_LOG.Lines.ADD ('=');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);

    ED_LOG.Lines.ADD ('###################');
    ED_LOG.Lines.ADD ('##  BN_mul TEST  ##');
    ED_LOG.Lines.ADD ('###################');
    // ----
    S_1 := '11111111112222222222333333333344444444445555555555';
    S_2 := '55555555556666666666777777777788888888889999999999';
    // ----
    BN_Base10 (bnx_1, S_1);
    BN_Base10 (bnx_2, S_2);
    BN_mul (bnx_R, bnx_1, bnx_2);
    // ----
    S_R := BN_Base10 (bnx_R);
    ED_LOG.Lines.ADD (S_1);
    ED_LOG.Lines.ADD ('*');
    ED_LOG.Lines.ADD (S_2);
    ED_LOG.Lines.ADD ('=');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);

    ED_LOG.Lines.ADD ('###################');
    ED_LOG.Lines.ADD ('##  BN_div TEST  ##');
    ED_LOG.Lines.ADD ('###################');
    // ----
    S_1 := '11111111112222222222333333333344444444445555555555';
    S_2 := '55555555556666666666777777777788888888889999999999';
    // ----
    BN_Base10 (bnx_1, S_1);
    BN_Base10 (bnx_2, S_2);
    BN_div (bnx_R, bnx_1, bnx_2);
    // ----
    S_R := BN_Base10 (bnx_R);
    ED_LOG.Lines.ADD (S_1);
    ED_LOG.Lines.ADD ('/');
    ED_LOG.Lines.ADD (S_2);
    ED_LOG.Lines.ADD ('=');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);

    ED_LOG.Lines.ADD ('###################');
    ED_LOG.Lines.ADD ('##  BN_div TEST  ##');
    ED_LOG.Lines.ADD ('###################');
    // ----
    S_1 := '11111111112222222222333333333344444444445555555555';
    S_2 := '55555555556666666666777777777788888888889999999999';
    // ----
    BN_Base10 (bnx_1, S_1);
    BN_Base10 (bnx_2, S_2);
    BN_div (bnx_R, bnx_2, bnx_1);
    // ----
    S_R := BN_Base10 (bnx_R);
    ED_LOG.Lines.ADD (S_2);
    ED_LOG.Lines.ADD ('/');
    ED_LOG.Lines.ADD (S_1);
    ED_LOG.Lines.ADD ('=');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);

    ED_LOG.Lines.ADD ('###################');
    ED_LOG.Lines.ADD ('##  BN_mod TEST  ##');
    ED_LOG.Lines.ADD ('###################');
    // ----
    S_1 := '11111111112222222222333333333344444444445555555555';
    S_2 := '55555555556666666666777777777788888888889999999999';
    // ----
    BN_Base10 (bnx_1, S_1);
    BN_Base10 (bnx_2, S_2);
    BN_mod (bnx_R, bnx_1, bnx_2);
    // ----
    S_R := BN_Base10 (bnx_R);
    ED_LOG.Lines.ADD (S_1);
    ED_LOG.Lines.ADD ('%');
    ED_LOG.Lines.ADD (S_2);
    ED_LOG.Lines.ADD ('=');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);

    ED_LOG.Lines.ADD ('###################');
    ED_LOG.Lines.ADD ('##  BN_mod TEST  ##');
    ED_LOG.Lines.ADD ('###################');
    // ----
    S_1 := '11111111112222222222333333333344444444445555555555';
    S_2 := '55555555556666666666777777777788888888889999999999';
    // ----
    BN_Base10 (bnx_1, S_1);
    BN_Base10 (bnx_2, S_2);
    BN_mod (bnx_R, bnx_2, bnx_1);
    // ----
    S_R := BN_Base10 (bnx_R);
    ED_LOG.Lines.ADD (S_2);
    ED_LOG.Lines.ADD ('%');
    ED_LOG.Lines.ADD (S_1);
    ED_LOG.Lines.ADD ('=');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);

    ED_LOG.Lines.ADD ('####################');
    ED_LOG.Lines.ADD ('##  BN_sqrt TEST  ##');
    ED_LOG.Lines.ADD ('####################');
    // ----
    BN_pow_int (bnx_100, 1, 100, 2222); // bnx_100 = (100^2222)
    BN_mul_int (bnx_0, bnx_100, 1, 2);  // bnx_0   = (100^2222)*2
    BN_sqrt (bnx_2, bnx_0);             // bnx_2   = sqrt((100^2222)*2)
    // ----
    S_R := BN_Base10 (bnx_2);
    ED_LOG.Lines.ADD ('sqrt(2*(100^2222)) = sqrt(2)*(10^2222) = ');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);

    ED_LOG.Lines.ADD ('####################');
    ED_LOG.Lines.ADD ('##  BN_fact TEST  ##');
    ED_LOG.Lines.ADD ('####################');
    // ----
    BN_fact (bnx_0, 1111); // bnx_0 = 1111!
    // ----
    S_R := BN_Base10 (bnx_0);
    ED_LOG.Lines.ADD ('1111! = ');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);

    ED_LOG.Lines.ADD ('#######################');
    ED_LOG.Lines.ADD ('##  BN_pow_int TEST  ##');
    ED_LOG.Lines.ADD ('#######################');
    // ----
    BN_pow_int (bnx_0, 3, 1000);
    // ----
    S_R := BN_Base10 (bnx_0);
    ED_LOG.Lines.ADD ('3^1000 = ');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);

    ED_LOG.Lines.ADD ('#######################');
    ED_LOG.Lines.ADD ('##  BN_pow_int TEST  ##');
    ED_LOG.Lines.ADD ('#######################');
    // ----
    BN_pow_int (bnx_0, 5, 10000);
    // ----
    S_R := BN_Base10 (bnx_0);
    ED_LOG.Lines.ADD ('5^10000 = ');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);

    ED_LOG.Lines.ADD ('#######################');
    ED_LOG.Lines.ADD ('##  BN_pow_mod TEST  ##');
    ED_LOG.Lines.ADD ('#######################');
    // ----
    BN_base10 (bnx_1, '540019781128412936473322405310');
    BN_base10 (bnx_2, '515692107665463680305819378593');
    BN_base10 (bnx_3, '750791094644726559640638407699');
    // 151232511393500655853002423778
    // ----
    BN_pow_mod (bnx_0, bnx_1, bnx_2, bnx_3);
    // ----
    S_R := BN_Base10 (bnx_0);
    ED_LOG.Lines.ADD ('(a^e) mod n = ');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);

    ED_LOG.Lines.ADD ('###########################');
    ED_LOG.Lines.ADD ('##  BN_pow_mod_mon TEST  ##');
    ED_LOG.Lines.ADD ('###########################');
    // ----
    BN_base10 (bnx_1, '540019781128412936473322405310');
    BN_base10 (bnx_2, '515692107665463680305819378593');
    BN_base10 (bnx_3, '750791094644726559640638407699');
    // 151232511393500655853002423778
    // ----
    BN_pow_mod_mon (bnx_0, bnx_1, bnx_2, bnx_3);
    // ----
    S_R := BN_Base10 (bnx_0);
    ED_LOG.Lines.ADD ('(a^e) mod n = ');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);

    ED_LOG.Lines.ADD ('############################');
    ED_LOG.Lines.ADD ('##  BN_GenPrime_BBS TEST  ##');
    ED_LOG.Lines.ADD ('############################');
    // ----
    BN_BBS_Random_Init (32, false);
    // BN_BBS_Random_Init (512, false);
    // BN_BBS_Random_Init (1024, false);
    BN_GenPrime_BBS (bnx_0, 512);
    // BN_GenPrime_BBS (bnx_0, 1024);
    // ----
    S_R := BN_Base10 (bnx_0);
    ED_LOG.Lines.ADD ('Prime = ');
    ED_LOG.Lines.ADD (S_R);
    ED_LOG.Lines.ADD ('');
    ED_LOG.Lines.ADD ('');
    Refresh_(T);

    ED_LOG.Lines.ADD ('#######################');
    ED_LOG.Lines.ADD ('##  This is the end  ##');
    ED_LOG.Lines.ADD ('#######################');

    BN_LFree (bnx_0);
    BN_LFree (bnx_1);
    BN_LFree (bnx_2);
    BN_LFree (bnx_3);
    BN_LFree (bnx_100);
    BN_LFree (bnx_R);
  finally
    Screen.Cursor := VCursor;
  end;

  Refresh_(T, true);
end;

end.

