unit mxBNMathProcs;

// Binuar 1.2.1
// Big integer number arithmetic
// ---
// Copyright  2000-3000, Andrey A. Meshkov (AL-CHEMIST)
// All rights reserved
//
// http://maalchemist.ru
// maa@maalchemist.ru
// maalchemist@yandex.ru
// maalchemist@gmail.com
//
// Free for any use.
// No warranty of any kind.
// ---

{$I version.inc}
{$I mxBNMath.inc}

interface

uses
  mxBNMathTypes;

function  BN_Alloc (var V: T_BNX; ACount: IntX): IntX; overload; // {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_Alloc (var V: T_BNX; ASign: ShortInt; ACount: IntX): IntX; overload; // {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_ReAlloc (var V: T_BNX; ACount: IntX): IntX; // {$IFDEF BN_INLINE} inline; {$ENDIF}
procedure BN_Free (var V: T_BNX); overload; {$IFDEF BN_INLINE} inline; {$ENDIF}
procedure BN_Free (var V: T_BNX_Array); overload; // {$IFDEF BN_INLINE} inline; {$ENDIF}
procedure BN_LFree (var V: T_BNX); overload; {$IFDEF BN_INLINE} inline; {$ENDIF}
procedure BN_LFree (var V: T_BNX_Array); overload; // {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_Init (var V: T_BNX; ACount: IntX): IntX; overload; {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_Init (var V: T_BNX; ASign: ShortInt; ACount: IntX): IntX; overload; {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_CInit (var V: T_BNX; ACount: IntX; const A: T_BNX; ACCount: IntX): IntX; overload; // {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_CInit (var V: T_BNX; ASign: ShortInt; ACount: IntX; const A: T_BNX; ACCount: IntX): IntX; overload; // {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_Norm (var V: T_BNX): IntX; overload; // {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_Norm (var V: T_BNX; ASign: ShortInt): IntX; overload; // {$IFDEF BN_INLINE} inline; {$ENDIF}

function  BN_DataCount (const V: T_BNX): IntX; {$IFDEF BN_INLINE} inline; {$ENDIF}

function  BN_LT_Zero (const V: T_BNX): Boolean; {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_LE_Zero (const V: T_BNX): Boolean; {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_EQ_Zero (const V: T_BNX): Boolean; {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_NE_Zero (const V: T_BNX): Boolean; {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_GE_Zero (const V: T_BNX): Boolean; {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_GT_Zero (const V: T_BNX): Boolean; {$IFDEF BN_INLINE} inline; {$ENDIF}

function  BN_IsZero (const V: T_BNX): Boolean; overload; {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_IsZero (const V: T_BNX; var ACount: IntX): Boolean; overload; {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_IsNotZero (const V: T_BNX): Boolean; overload; {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_IsNotZero (const V: T_BNX; var ACount: IntX): Boolean; overload; {$IFDEF BN_INLINE} inline; {$ENDIF}

function  BN_IsOne (const V: T_BNX): Boolean; {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_IsPOne (const V: T_BNX): Boolean; {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_IsNOne (const V: T_BNX): Boolean; {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_IsInt (const V: T_BNX; var AUInt: UIntX): Boolean; overload; {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_IsInt (const V: T_BNX; var ASign: ShortInt; var AUInt: UIntX): Boolean; overload; {$IFDEF BN_INLINE} inline; {$ENDIF}

function  BN_DataBytes (const V: T_BNX; var ACount: IntX): UIntX; overload;
function  BN_DataBytes (const V: T_BNX): UIntX; overload;
function  BN_DataNibbles (const V: T_BNX; var ACount: IntX): UIntX; overload;
function  BN_DataNibbles (const V: T_BNX): UIntX; overload;
function  BN_DataBits (const V: T_BNX; var ACount: IntX): UIntX; overload;
function  BN_DataBits (const V: T_BNX): UIntX; overload;

function  BN_DataValue (const V: T_BNX): UIntX;

function  BN_AssignZero (var V: T_BNX): IntX; {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_AssignOne (var V: T_BNX; ASign: ShortInt): IntX; {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_AssignPOne (var V: T_BNX): IntX; {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_AssignNOne (var V: T_BNX): IntX; {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_AssignInt (var V: T_BNX; ASign: ShortInt; AUInt: UIntX): IntX; overload; // {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_AssignInt (var V: T_BNX; AInt: IntX): IntX; overload; // {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_AssignBit (var V: T_BNX; ABit: IntX): IntX; overload; // {$IFDEF BN_INLINE} inline; {$ENDIF}
function  BN_AssignBit (var V: T_BNX; ASign: ShortInt; ABit: IntX): IntX; overload; // {$IFDEF BN_INLINE} inline; {$ENDIF}
procedure BN_AssignBits (var V: T_BNX; ASign: ShortInt; ABits: UIntX); overload; // {$IFDEF BN_INLINE} inline; {$ENDIF}

function  BN_TestSBit (const A: T_BNX; ABit: UIntX): Boolean; overload;
function  BN_TestCBit (const A: T_BNX; ABit: UIntX): Boolean; overload;
procedure BN_ClearBit (var V: T_BNX; ABit: UIntX); overload;
procedure BN_ClearBit (var V: T_BNX; const A: T_BNX; ABit: UIntX); overload;
procedure BN_SetBit (var V: T_BNX; ABit: UIntX); overload;
procedure BN_SetBit (var V: T_BNX; const A: T_BNX; ABit: UIntX); overload;
procedure BN_ToggleBit (var V: T_BNX; ABit: UIntX); overload;
procedure BN_ToggleBit (var V: T_BNX; const A: T_BNX; ABit: UIntX); overload;

function  BN_Pack (var V: T_BNX): IntX; {$IFDEF BN_INLINE} inline; {$ENDIF}

function  BN_Resize (var V: T_BNX; ACount: IntX): IntX; overload;
function  BN_Resize (var V: T_BNX; ASign: ShortInt; ACount: IntX): IntX; overload;

function  BN_Increase (var V: T_BNX): IntX; overload;
function  BN_Increase (var V: T_BNX; const A: T_BNX): IntX; overload;
function  BN_Increase (var V: T_BNX; ACount: IntX): IntX; overload;
function  BN_Increase (var V: T_BNX; const A: T_BNX; ACount: IntX): IntX; overload;
function  BN_Decrease (var V: T_BNX): IntX; overload;
function  BN_Decrease (var V: T_BNX; const A: T_BNX): IntX; overload;
function  BN_Decrease (var V: T_BNX; ACount: IntX): IntX; overload;
function  BN_Decrease (var V: T_BNX; const A: T_BNX; ACount: IntX): IntX; overload;

function  BN_Compare (const V1, V2: T_BNX): Integer; overload;
function  BN_Compare (const V1: T_BNX; V2: IntX): Integer; overload;
function  BN_Compare (const V1: T_BNX; ASign2: ShortInt; V2: UIntX): Integer; overload;
function  BN_DataCompare (const V1, V2: T_BNX): Integer; overload;
function  BN_DataCompare (const V1: T_BNX; V2: UIntX): Integer; overload;

function  BN_IsPowerOfTwo (const A: T_BNX): Boolean; overload;
function  BN_IsPowerOfTwo (const A: UIntX): Boolean; overload;
function  BN_IsPowerOfTwo (const A: T_BNX; var ABit: IntX): Boolean; overload;
function  BN_IsPowerOfTwo (const A: UIntX; var ABit: IntX): Boolean; overload;

function  BN_AsInt (const V: T_BNX): UIntX; overload;
function  BN_AsInt (const V: T_BNX; var ASign: ShortInt): UIntX; overload;

function  BN_IsOdd (const V: T_BNX): Boolean;
function  BN_IsEven (const V: T_BNX): Boolean;

function  BN_Min (var V: T_BNX; const A, B: T_BNX): Integer;
function  BN_Max (var V: T_BNX; const A, B: T_BNX): Integer;
function  BN_AbsMin (var V: T_BNX; const A, B: T_BNX): Integer;
function  BN_AbsMax (var V: T_BNX; const A, B: T_BNX): Integer;

function  BN_GetGPSquare (var V: T_BNX; ABreak: PBoolean = nil): Boolean;
function  BN_GetLPSquare (var V: T_BNX; ABreak: PBoolean = nil): Boolean;

function  BN_GetGCoPrime (var V: T_BNX; const A: T_BNX): Boolean;
function  BN_GetLCoPrime (var V: T_BNX; const A: T_BNX): Boolean;
function  BN_GetGPrime (var V: T_BNX; R: Integer = 64; ABreak: PBoolean = nil): Boolean;
function  BN_GetLPrime (var V: T_BNX; R: Integer = 64; ABreak: PBoolean = nil): Boolean;

function  BN_GenPrime (var V: T_BNX; ABits: UIntX; R: Integer = 64; ABreak: PBoolean = nil): Boolean;
function  BN_GenPrime_DH (var V: T_BNX; ABits: UIntX; R: Integer = 64; ABreak: PBoolean = nil): Boolean;
function  BN_GenPrime_BBS (var V: T_BNX; ABits: UIntX; R: Integer = 64; ABreak: PBoolean = nil): Boolean;
function  BN_GenPrime_3m4 (var V: T_BNX; ABits: UIntX; R: Integer = 64; ABreak: PBoolean = nil): Boolean;

function  BN_PrimeTest (const n: T_BNX; R: Integer = 64; ABreak: PBoolean = nil): Boolean;
function  BN_PrimeTest_Miller_Rabin (const n: T_BNX; R: Integer = 64; ABreak: PBoolean = nil): Boolean;

function  BN_RSATest (const p: T_BNX): Boolean;
function  BN_DHTest (const g: T_BNX): Boolean;

function  BN_Factor_Fermat (var p, q: T_BNX; const n: T_BNX; ABreak: PBoolean = nil): Integer;
function  BN_Factor_Fermat_2m (var p, q: T_BNX; const n: T_BNX; m: UIntX; ABreak: PBoolean = nil): Integer;
function  BN_Factor_SQUFOF (var p, q: T_BNX; const n: T_BNX; ABreak: PBoolean = nil): Integer;

implementation

uses
  mxBNMath, mxBNMathConv, mxBNMathRandom, mxBNMathUtils, mxBNMathPrimes;

// [+] 1.2.1
{
  Allocate positive number
}
function BN_Alloc (var V: T_BNX; ACount: IntX): IntX;
var
  VHIndex : IntX;
begin
  if ACount <= 0 then begin
    BN_Free (V);
    Result := 0;
    Exit;
  end;

  Result := ACount;
  V.Sign := 1;

  VHIndex := ACount - 1;
  if HIGH(V.Data) = VHIndex then Exit;

  SetLength (V.Data, ACount);

  V.Count := ACount;
  V.HIndex := VHIndex;
  V.PLData := @V.Data[0];
  V.PHData := @V.Data[VHIndex];
end;

{
  Allocate number
}
function BN_Alloc (var V: T_BNX; ASign: ShortInt; ACount: IntX): IntX;
var
  VHIndex : IntX;
begin
  if (ASign = 0) or (ACount <= 0) then begin
    BN_Free (V);
    Result := 0;
    Exit;
  end;

  Result := ACount;
  V.Sign := ASign;

  VHIndex := ACount - 1;
  if HIGH(V.Data) = VHIndex then Exit;

  SetLength (V.Data, ACount);

  V.Count := ACount;
  V.HIndex := VHIndex;
  V.PLData := @V.Data[0];
  V.PHData := @V.Data[VHIndex];
end;

{
  Reallocate number
}
function BN_ReAlloc (var V: T_BNX; ACount: IntX): IntX;
var
  VHIndex : IntX;
begin
  if ACount <= 0 then begin
    BN_Free (V);
    Result := 0;
    Exit;
  end;

  Result := ACount;
  if V.Sign = 0 then V.Sign := 1;

  VHIndex := ACount - 1;
  if HIGH(V.Data) = VHIndex then Exit;

  SetLength (V.Data, ACount);

  V.Count := ACount;
  V.HIndex := VHIndex;
  V.PLData := @V.Data[0];
  V.PHData := @V.Data[VHIndex];
end;

{
  Free variable
}
procedure BN_Free (var V: T_BNX);
begin
  V.Data := nil;
  // SetLength (V.Data, 0);

  V.Sign := 0;
  V.Count := 0;
  V.HIndex := -1;
  V.PLData := nil;
  V.PHData := nil;
end;

// [+] 1.2.1
{
  Free variables
}
procedure BN_Free (var V: T_BNX_Array);
var
  I : LoopInt;
begin
  for I := 0 to HIGH(V) do BN_Free (V[I]);
end;

// [+] 1.2.1
{
  Free local variable
}
procedure BN_LFree (var V: T_BNX);
begin
end;
(*
begin
  V.Data := nil;
  // SetLength (V.Data, 0);

  V.Sign := 0;
  V.Count := 0;
  V.HIndex := -1;
  V.PLData := nil;
  V.PHData := nil;
end;
// *)

// [+] 1.2.1
{
  Free local variables
}
procedure BN_LFree (var V: T_BNX_Array);
begin
end;
(*
var
  I : LoopInt;
begin
  for I := 0 to HIGH(V) do BN_LFree (V[I]);
end;
// *)

// [+] 1.2.1
{
  Init positive number
}
function BN_Init (var V: T_BNX; ACount: IntX): IntX;
begin
  Result := BN_Alloc (V, ACount);
  if V.Count <= 0 then Exit;

  BN_ZeroData (V.PLData, V.Count);
end;

{
  Init number
}
function BN_Init (var V: T_BNX; ASign: ShortInt; ACount: IntX): IntX;
begin
  Result := BN_Alloc (V, ASign, ACount);
  if V.Count <= 0 then Exit;

  BN_ZeroData (V.PLData, V.Count);
end;

// [+] 1.2.1
{
  Init number V and copy first ACCount elements from A
}
function BN_CInit (var V: T_BNX; ACount: IntX;
  const A: T_BNX; ACCount: IntX): IntX;
var
  VDCount : IntX;
begin
  Result := BN_Alloc (V, ACount);
  if V.Count <= 0 then Exit;

  if (A.Count <= 0) or (ACCount <= 0) then begin
    BN_ZeroData (V.PLData, V.Count);
    Exit;
  end;

  if ACCount > A.Count then ACCount := A.Count;
  VDCount := ACount - ACCount;

  if VDCount > 0 then begin
    BN_CopyData (V.PLData, A.PLData, ACCount);
    BN_ZeroData (@V.Data[ACCount], VDCount);
  end else begin
    BN_CopyData (V.PLData, A.PLData, V.Count);
  end;
end;

// [+] 1.2.1
{
  Init number V and copy first ACCount elements from A
}
function BN_CInit (var V: T_BNX; ASign: ShortInt; ACount: IntX;
  const A: T_BNX; ACCount: IntX): IntX;
var
  VDCount : IntX;
begin
  Result := BN_Alloc (V, ASign, ACount);
  if V.Count <= 0 then Exit;

  if (A.Count <= 0) or (ACCount <= 0) then begin
    BN_ZeroData (V.PLData, V.Count);
    Exit;
  end;

  if ACCount > A.Count then ACCount := A.Count;
  VDCount := ACount - ACCount;

  if VDCount > 0 then begin
    BN_CopyData (V.PLData, A.PLData, ACCount);
    BN_ZeroData (@V.Data[ACCount], VDCount);
  end else begin
    BN_CopyData (V.PLData, A.PLData, V.Count);
  end;
end;

// [+] 1.2.1
{
  Normalize number fields
}
function BN_Norm (var V: T_BNX): IntX;
var
  VCount  : IntX;
  VHIndex : IntX;
  VPCount : IntX;
  VPLData : PUIntX;
  VPHData : PUIntX;
  VValid  : Boolean;
begin
  VHIndex := HIGH(V.Data);
  VCount := VHIndex + 1;
  Result := VCount;

  VPCount := V.Count;
  VPLData := V.PLData;
  VPHData := V.PHData;

  V.Count := VCount;
  V.HIndex := VHIndex;

  if VCount > 0 then begin
    V.PLData := @V.Data[0];
    V.PHData := @V.Data[VHIndex];

    VValid := (VPCount = VCount) and (VPLData = V.PLData) and (VPHData = V.PHData);
    if VValid then begin
      if V.Sign = 0 then V.Sign := 1 else
      if V.Sign > 0 then V.Sign := 1 else
      if V.Sign < 0 then V.Sign := -1;
    end else begin
      V.Sign := 1;
    end;
  end else begin
    V.Sign := 0;
    V.PLData := nil;
    V.PHData := nil;
  end;
end;

// [+] 1.2.1
{
  Normalize number fields
}
function BN_Norm (var V: T_BNX; ASign: ShortInt): IntX;
var
  VCount  : IntX;
  VHIndex : IntX;
begin
  VHIndex := HIGH(V.Data);
  VCount := VHIndex + 1;
  Result := VCount;

  V.Count := VCount;
  V.HIndex := VHIndex;

  if VCount > 0 then begin
    V.PLData := @V.Data[0];
    V.PHData := @V.Data[VHIndex];

    if ASign = 0 then ASign := 1 else
    if ASign > 0 then ASign := 1 else
    if ASign < 0 then ASign := -1;
    V.Sign := ASign;
  end else begin
    V.Sign := 0;
    V.PLData := nil;
    V.PHData := nil;
  end;
end;

{
       
  The number of elements excluding the upper zeros
}
function BN_DataCount (const V: T_BNX): IntX;
var
  I : LoopInt;
  H : IntX;
begin
  H := HIGH(V.Data);
  Result := H + 1;
  if Result = 0 then Exit;

  for I := H downto 0 do begin
    if V.Data[I] <> 0 then Exit;
    Dec (Result);
  end;
end;
(*
begin
  Result := V.Count;
end;
// *)

// [+] 1.2.1
{
  ? V < 0
}
function BN_LT_Zero (const V: T_BNX): Boolean;
var
  VCount : IntX;
begin
  VCount := BN_DataCount (V);

  if (V.Sign = 0) or (VCount <= 0) then begin
    Result := false; // V = 0
    Exit;
  end;

  Result := V.Sign < 0;
end;

// [+] 1.2.1
{
  ? V <= 0
}
function BN_LE_Zero (const V: T_BNX): Boolean;
var
  VCount : IntX;
begin
  VCount := BN_DataCount (V);

  if (V.Sign = 0) or (VCount <= 0) then begin
    Result := true; // V = 0
    Exit;
  end;

  Result := V.Sign < 0;
end;

// [+] 1.2.1
{
  ? V = 0
}
function BN_EQ_Zero (const V: T_BNX): Boolean;
var
  VCount : IntX;
begin
  VCount := BN_DataCount (V);
  Result := (V.Sign = 0) or (VCount <= 0);
end;

// [+] 1.2.1
{
  ? V <> 0
}
function BN_NE_Zero (const V: T_BNX): Boolean;
var
  VCount : IntX;
begin
  VCount := BN_DataCount (V);
  Result := (V.Sign <> 0) and (VCount > 0);
end;

// [+] 1.2.1
{
  ? V >= 0
}
function BN_GE_Zero (const V: T_BNX): Boolean;
var
  VCount : IntX;
begin
  VCount := BN_DataCount (V);

  if (V.Sign = 0) or (VCount <= 0) then begin
    Result := true; // V = 0
    Exit;
  end;

  Result := V.Sign > 0;
end;

// [+] 1.2.1
{
  ? V > 0
}
function BN_GT_Zero (const V: T_BNX): Boolean;
var
  VCount : IntX;
begin
  VCount := BN_DataCount (V);

  if (V.Sign = 0) or (VCount <= 0) then begin
    Result := false; // V = 0
    Exit;
  end;

  Result := V.Sign > 0;
end;

{
  ? V = 0
}
function BN_IsZero (const V: T_BNX): Boolean;
var
  VCount : IntX;
begin
  VCount := BN_DataCount (V);
  Result := (V.Sign = 0) or (VCount <= 0);
end;

// [+] 1.2.1
{
  ? V = 0
}
function BN_IsZero (const V: T_BNX; var ACount: IntX): Boolean;
begin
  ACount := BN_DataCount (V);
  Result := (V.Sign = 0) or (ACount <= 0);
end;

// [+] 1.2.1
{
  ? V <> 0
}
function BN_IsNotZero (const V: T_BNX): Boolean;
var
  VCount : IntX;
begin
  VCount := BN_DataCount (V);
  Result := (V.Sign <> 0) and (VCount > 0);
end;

// [+] 1.2.1
{
  ? V <> 0
}
function BN_IsNotZero (const V: T_BNX; var ACount: IntX): Boolean;
begin
  ACount := BN_DataCount (V);
  Result := (V.Sign <> 0) and (ACount > 0);
end;

{
  ? |V| = 1
}
function BN_IsOne (const V: T_BNX): Boolean;
var
  VCount : IntX;
begin
  Result := false;

  VCount := BN_DataCount (V);
  if (V.Sign <> 0) and (VCount = 1) then begin
    Result := V.Data[0] = 1;
  end;
end;

// [+] 1.2.1
{
  ? V = +1
}
function BN_IsPOne (const V: T_BNX): Boolean;
var
  VCount : IntX;
begin
  Result := false;

  VCount := BN_DataCount (V);
  if (V.Sign > 0) and (VCount = 1) then begin
    Result := V.Data[0] = 1;
  end;
end;

// [+] 1.2.1
{
  ? V = +1
}
function BN_IsNOne (const V: T_BNX): Boolean;
var
  VCount : IntX;
begin
  Result := false;

  VCount := BN_DataCount (V);
  if (V.Sign < 0) and (VCount = 1) then begin
    Result := V.Data[0] = 1;
  end;
end;

{
}
function BN_IsInt (const V: T_BNX; var AUInt: UIntX): Boolean;
var
  VCount : IntX;
begin
  Result := false;
  AUInt := 0;

  VCount := BN_DataCount (V);
  if (V.Sign <> 0) and (VCount = 1) then begin
    AUInt := V.Data[0];
    Result := true;
  end;
end;

{
}
function BN_IsInt (const V: T_BNX; var ASign: ShortInt; var AUInt: UIntX): Boolean;
var
  VCount : IntX;
begin
  Result := false;
  ASign := V.Sign;
  AUInt := 0;

  VCount := BN_DataCount (V);
  if (V.Sign <> 0) and (VCount = 1) then begin
    AUInt := V.Data[0];
    Result := true;
  end;
end;

{
       
  The number of elements excluding the upper zeros

  Pure pascal
}
function BN_DataCount_PP (const V: T_BNX): IntX;
var
  I : LoopInt;
begin
  Result := V.Count;
  for I := V.HIndex downto 0 do begin
    if V.Data[I] <> 0 then Break;
    Dec (Result);
  end;
end;

{
       
  The number of bytes excluding the upper zeros
}
function BN_DataBytes (const V: T_BNX; var ACount: IntX): UIntX;
var
  VUCount : UIntX;
begin
  Result := 0;
  ACount := 0;
  if V.Sign = 0 then Exit;

  ACount := BN_DataCount (V);
  if ACount <= 0 then Exit;

  VUCount := ACount - 1;
  Result := BN_Bytes (V.Data[VUCount]);

  {$IFDEF CPUX64}
  Result := Result + (VUCount shl 3); // ... Result + VUCount * 8;
  {$ELSE}
  Result := Result + (VUCount shl 2); // ... Result + VUCount * 4;
  {$ENDIF}
end;

{
       
  The number of bytes excluding the upper zeros
}
function BN_DataBytes (const V: T_BNX): UIntX;
var
  VCount : IntX;
begin
  Result := BN_DataBytes (V, VCount);
end;

{
       
  The number of half-bytes excluding the upper zeros
}
function BN_DataNibbles (const V: T_BNX; var ACount: IntX): UIntX;
var
  VUCount : UIntX;
begin
  Result := 0;
  ACount := 0;
  if V.Sign = 0 then Exit;

  ACount := BN_DataCount (V);
  if ACount <= 0 then Exit;

  VUCount := ACount - 1;
  Result := BN_Nibbles (V.Data[VUCount]);

  {$IFDEF CPUX64}
  Result := Result + (VUCount shl 4); // ... Result + VUCount * 16;
  {$ELSE}
  Result := Result + (VUCount shl 3); // ... Result + VUCount * 8;
  {$ENDIF}
end;

{
       
  The number of half-bytes excluding the upper zeros
}
function BN_DataNibbles (const V: T_BNX): UIntX;
var
  VCount : IntX;
begin
  Result := BN_DataNibbles (V, VCount);
end;

{
       
  The number of bits excluding the upper zeros
}
function BN_DataBits (const V: T_BNX; var ACount: IntX): UIntX;
var
  VUCount : UIntX;
begin
  Result := 0;
  ACount := 0;
  if V.Sign = 0 then Exit;

  ACount := BN_DataCount (V);
  if ACount <= 0 then Exit;

  VUCount := ACount - 1;
  Result := BN_Bits (V.Data[VUCount]);

  {$IFDEF CPUX64}
  Result := Result + (VUCount shl 6); // ... Result + VUCount * 64;
  {$ELSE}
  Result := Result + (VUCount shl 5); // ... Result + VUCount * 32;
  {$ENDIF}
end;

{
       
  The number of bits excluding the upper zeros
}
function BN_DataBits (const V: T_BNX): UIntX;
var
  VCount : IntX;
begin
  Result := BN_DataBits (V, VCount);
end;

{
       0
  Return the value of a single element or 0
}
function BN_DataValue (const V: T_BNX): UIntX;
var
  VCount : IntX;
begin
  Result := 0;

  VCount := BN_DataCount (V);
  if VCount = 1 then Result := V.Data[0];
end;

{
  V = 0
}
function BN_AssignZero (var V: T_BNX): IntX;
begin
  Result := BN_Alloc (V, 0, 0);
end;

// [+] 1.2.1
{
  Assign signed 1
  V = +1 or -1
}
function BN_AssignOne (var V: T_BNX; ASign: ShortInt): IntX;
begin
  Result := BN_Alloc (V, ASign, 1);
  if Result > 0 then V.Data[0] := 1;
end;

// [+] 1.2.1
{
  Assign positive 1
  V = +1
}
function BN_AssignPOne (var V: T_BNX): IntX;
begin
  Result := BN_Alloc (V, 1);
  if Result > 0 then V.Data[0] := 1;
end;

// [+] 1.2.1
{
  Assign negative 1
  V = -1
}
function BN_AssignNOne (var V: T_BNX): IntX;
begin
  Result := BN_Alloc (V, -1, 1);
  if Result > 0 then V.Data[0] := 1;
end;

{
}
function BN_AssignInt (var V: T_BNX; ASign: ShortInt; AUInt: UIntX): IntX;
begin
  if AUInt = 0 then begin
    Result := BN_AssignZero (V);
    Exit;
  end;

  Result := BN_Alloc (V, ASign, 1);
  if Result > 0 then V.Data[0] := AUInt;
end;

{
  AInt - signed integer
}
function BN_AssignInt (var V: T_BNX; AInt: IntX): IntX;
var
  VSign : ShortInt;
begin
  if AInt = 0 then begin
    Result := BN_AssignZero (V);
    Exit;
  end;

  if AInt > 0 then VSign := 1
  else begin
    VSign := -1;
    AInt := -AInt;
  end;

  Result := BN_Alloc (V, VSign, 1);
  if Result > 0 then V.Data[0] := AInt;
end;

// [+] 1.2.1
{
           ABit
  Create a positive number with the only bit set at the ABit position

  ABit = 0,1,...
}
function BN_AssignBit (var V: T_BNX; ABit: IntX): IntX;
var
  VmBits : UIntX;
  VCount : IntX;
begin
  if ABit < 0 then begin
    Result := BN_AssignZero (V);
    Exit;
  end;

  VCount := div_mod (ABit, CXBits, VmBits) + 1;

  Result := BN_Init (V, VCount);
  V.PHData^ := UIntX(1) shl VmBits;
end;

{
          ABit
  Create a number with the only bit set at the ABit position

  ABit = 0,1,...
}
function BN_AssignBit (var V: T_BNX; ASign: ShortInt; ABit: IntX): IntX;
var
  VmBits : UIntX;
  VCount : IntX;
begin
  if ABit < 0 then begin
    Result := BN_AssignZero (V);
    Exit;
  end;

  VCount := div_mod (ABit, CXBits, VmBits) + 1;

  Result := BN_Init (V, ASign, VCount);
  V.PHData^ := UIntX(1) shl VmBits;
end;

// [+] 1.2.1
{
}
procedure BN_AssignBits (var V: T_BNX; ASign: ShortInt; ABits: UIntX);
var
  I : LoopInt;
begin
  if BN_IsZero (V) then begin
    BN_AssignZero (V);
    Exit;
  end;

  for I := 0 to V.HIndex do begin
    V.Data[I] := ABits;
  end;
end;

// [+] 1.2.1
{
  Returns TRUE if the bit at the ABit position is set
  ABit = 0,1,...
}
function BN_TestSBit (const A: T_BNX; ABit: UIntX): Boolean;
var
  VmBits : UIntX;
  VCount : IntX;
  VIndex : IntX;
  Vmask  : UIntX;
begin
  Result := false;

  VCount := div_mod (ABit, CXBits, VmBits) + 1;
  if VCount > BN_DataCount (A) then Exit;

  VIndex := VCount - 1;
  Vmask := UIntX(1) shl VmBits;
  Result := (A.Data[VIndex] and Vmask) <> 0;
end;

// [+] 1.2.1
{
  Returns TRUE if the bit at the ABit position is clear
  ABit = 0,1,...
}
function BN_TestCBit (const A: T_BNX; ABit: UIntX): Boolean;
var
  VmBits : UIntX;
  VCount : IntX;
  VIndex : IntX;
  Vmask  : UIntX;
begin
  Result := false;

  VCount := div_mod (ABit, CXBits, VmBits) + 1;
  if VCount > BN_DataCount (A) then Exit;

  VIndex := VCount - 1;
  Vmask := UIntX(1) shl VmBits;
  Result := (A.Data[VIndex] and Vmask) = 0;
end;

{
      ABit
  Clear the bit at the ABit position

  ABit = 0,1,...
}
procedure BN_ClearBit (var V: T_BNX; ABit: UIntX);
var
  VmBits : UIntX;
  VCount : IntX;
  VIndex : IntX;
  Vmask  : UIntX;
begin
  VCount := div_mod (ABit, CXBits, VmBits) + 1;
  if VCount > BN_DataCount (V) then Exit;

  VIndex := VCount - 1;
  Vmask := not (UIntX(1) shl VmBits);
  V.Data[VIndex] := V.Data[VIndex] and Vmask;
  BN_Pack (V);
end;

{
      ABit
  Clear the bit at the ABit position

  ABit = 0,1,...
}
procedure BN_ClearBit (var V: T_BNX; const A: T_BNX; ABit: UIntX);
var
  VmBits : UIntX;
  VCount : IntX;
  VIndex : IntX;
  Vmask  : UIntX;
begin
  BN_copy (V, A);

  VCount := div_mod (ABit, CXBits, VmBits) + 1;
  if VCount > BN_DataCount (V) then Exit;

  VIndex := VCount - 1;
  Vmask := not (UIntX(1) shl VmBits);
  V.Data[VIndex] := V.Data[VIndex] and Vmask;
  BN_Pack (V);
end;

// [+] 1.2.1
{
      ABit
  Set the bit at the ABit position

  ABit = 0,1,...
}
procedure BN_SetBit (var V: T_BNX; ABit: UIntX);
var
  VmBits : UIntX;
  VCount : IntX;
  VIndex : IntX;
  Vmask  : UIntX;
begin
  VCount := div_mod (ABit, CXBits, VmBits) + 1;
  if VCount > BN_DataCount (V) then Exit;

  VIndex := VCount - 1;
  Vmask := UIntX(1) shl VmBits;
  V.Data[VIndex] := V.Data[VIndex] or Vmask;
  BN_Pack (V);
end;

// [+] 1.2.1
{
      ABit
  Set the bit at the ABit position

  ABit = 0,1,...
}
procedure BN_SetBit (var V: T_BNX; const A: T_BNX; ABit: UIntX);
var
  VmBits : UIntX;
  VCount : IntX;
  VIndex : IntX;
  Vmask  : UIntX;
begin
  BN_copy (V, A);

  VCount := div_mod (ABit, CXBits, VmBits) + 1;
  if VCount > BN_DataCount (V) then Exit;

  VIndex := VCount - 1;
  Vmask := UIntX(1) shl VmBits;
  V.Data[VIndex] := V.Data[VIndex] or Vmask;
  BN_Pack (V);
end;

// [+] 1.2.1
{
      ABit
  Toggle the bit at the ABit position

  ABit = 0,1,...
}
procedure BN_ToggleBit (var V: T_BNX; ABit: UIntX);
var
  VmBits : UIntX;
  VCount : IntX;
  VIndex : IntX;
  Vmask  : UIntX;
begin
  VCount := div_mod (ABit, CXBits, VmBits) + 1;
  if VCount > BN_DataCount (V) then Exit;

  VIndex := VCount - 1;
  Vmask := UIntX(1) shl VmBits;
  V.Data[VIndex] := V.Data[VIndex] xor Vmask;
  BN_Pack (V);
end;

// [+] 1.2.1
{
      ABit
  Toggle the bit at the ABit position

  ABit = 0,1,...
}
procedure BN_ToggleBit (var V: T_BNX; const A: T_BNX; ABit: UIntX);
var
  VmBits : UIntX;
  VCount : IntX;
  VIndex : IntX;
  Vmask  : UIntX;
begin
  BN_copy (V, A);

  VCount := div_mod (ABit, CXBits, VmBits) + 1;
  if VCount > BN_DataCount (V) then Exit;

  VIndex := VCount - 1;
  Vmask := UIntX(1) shl VmBits;
  V.Data[VIndex] := V.Data[VIndex] xor Vmask;
  BN_Pack (V);
end;

{
    
  Remove the upper zeros
}
function BN_Pack (var V: T_BNX): IntX;
begin
  Result := BN_DataCount (V);
  if Result = V.Count then Exit;

  BN_ReAlloc (V, Result);
end;

{
}
function BN_Resize (var V: T_BNX; ACount: IntX): IntX;
var
  VCount  : IntX;
  VDCount : IntX;
begin
  VCount := V.Count;
  if ACount = VCount then begin
    Result := ACount;
    Exit;
  end;

  Result := BN_ReAlloc (V, ACount);

  VDCount := V.Count - VCount;
  if VDCount <= 0 then Exit;

  BN_ZeroData (@V.Data[VCount], VDCount);
end;

{
}
function BN_Resize (var V: T_BNX; ASign: ShortInt; ACount: IntX): IntX;
var
  VCount  : IntX;
  VDCount : IntX;
begin
  V.Sign := ASign;

  VCount := V.Count;
  if ACount = VCount then begin
    Result := ACount;
    Exit;
  end;

  Result := BN_ReAlloc (V, ACount);

  VDCount := V.Count - VCount;
  if VDCount <= 0 then Exit;

  BN_ZeroData (@V.Data[VCount], VDCount);
end;

// [+] 1.2.1
{
  V.Count = V.Count + 1
}
function BN_Increase (var V: T_BNX): IntX;
var
  I       : LoopInt;
  VCount  : IntX;
  VHIndex : IntX;
begin
  VCount := V.Count + 1;
  (*
  if VCount <= 0 then begin
    Result := BN_AssignZero (V);
    Exit;
  end;
  // *)

  VHIndex := VCount - 1;
  SetLength (V.Data, VCount);
  for I := V.Count to VHIndex do V.Data[I] := 0;

  V.Count := VCount;
  V.HIndex := VHIndex;
  V.PLData := @V.Data[0];
  V.PHData := @V.Data[VHIndex];

  Result := VCount;
end;

// [+] 1.2.1
{
  V <- A
  V.Count = A.Count + 1
}
function BN_Increase (var V: T_BNX; const A: T_BNX): IntX;
var
  I      : LoopInt;
  VCount : IntX;
begin
  VCount := A.Count + 1;
  (*
  if VCount <= 0 then begin
    Result := BN_AssignZero (V);
    Exit;
  end;
  // *)

  Result := BN_Alloc (V, A.Sign, VCount);
  BN_CopyData (V.PLData, A.PLData, A.Count);
  for I := A.Count to V.HIndex do V.Data[I] := 0;
end;

// [+] 1.2.1
{
  V.Count = V.Count + ACount
}
function BN_Increase (var V: T_BNX; ACount: IntX): IntX;
var
  I       : LoopInt;
  VCount  : IntX;
  VHIndex : IntX;
begin
  if ACount = 0 then begin
    Result := V.Count;
    Exit;
  end;

  VCount := V.Count + ACount;
  if VCount <= 0 then begin
    Result := BN_AssignZero (V);
    Exit;
  end;

  VHIndex := VCount - 1;
  SetLength (V.Data, VCount);
  for I := V.Count to VHIndex do V.Data[I] := 0;

  V.Count := VCount;
  V.HIndex := VHIndex;
  V.PLData := @V.Data[0];
  V.PHData := @V.Data[VHIndex];

  Result := VCount;
end;

// [+] 1.2.1
{
  V <- A
  V.Count = A.Count + ACount
}
function BN_Increase (var V: T_BNX; const A: T_BNX; ACount: IntX): IntX;
var
  I      : LoopInt;
  VCount : IntX;
begin
  if ACount = 0 then begin
    Result := BN_copy (V, A);
    Exit;
  end;

  VCount := A.Count + ACount;
  if VCount <= 0 then begin
    Result := BN_AssignZero (V);
    Exit;
  end;

  Result := BN_Alloc (V, A.Sign, VCount);
  if ACount > 0 then begin
    // A.Count < VCount
    BN_CopyData (V.PLData, A.PLData, A.Count);
    for I := A.Count to V.HIndex do V.Data[I] := 0;
  end else begin
    // A.Count > VCount
    BN_CopyData (V.PLData, A.PLData, VCount);
  end;
end;

// [+] 1.2.1
{
  V.Count = V.Count - 1
}
function BN_Decrease (var V: T_BNX): IntX;
var
  VCount  : IntX;
  VHIndex : IntX;
begin
  VCount := V.Count - 1;
  if VCount <= 0 then begin
    Result := BN_AssignZero (V);
    Exit;
  end;

  VHIndex := VCount - 1;
  SetLength (V.Data, VCount);

  V.Count := VCount;
  V.HIndex := VHIndex;
  V.PLData := @V.Data[0];
  V.PHData := @V.Data[VHIndex];

  Result := VCount;
end;

// [+] 1.2.1
{
  V <- A
  V.Count = A.Count - 1
}
function BN_Decrease (var V: T_BNX; const A: T_BNX): IntX;
var
  VCount : IntX;
begin
  VCount := A.Count - 1;
  if VCount <= 0 then begin
    Result := BN_AssignZero (V);
    Exit;
  end;

  Result := BN_Alloc (V, A.Sign, VCount);
  BN_CopyData (V.PLData, A.PLData, VCount);
end;

// [+] 1.2.1
{
  V.Count = V.Count - ACount
}
function BN_Decrease (var V: T_BNX; ACount: IntX): IntX;
var
  I       : LoopInt;
  VCount  : IntX;
  VHIndex : IntX;
begin
  if ACount = 0 then begin
    Result := V.Count;
    Exit;
  end;

  VCount := V.Count - ACount;
  if VCount <= 0 then begin
    Result := BN_AssignZero (V);
    Exit;
  end;

  VHIndex := VCount - 1;
  SetLength (V.Data, VCount);
  for I := V.Count to VHIndex do V.Data[I] := 0;

  V.Count := VCount;
  V.HIndex := VHIndex;
  V.PLData := @V.Data[0];
  V.PHData := @V.Data[VHIndex];

  Result := VCount;
end;

// [+] 1.2.1
{
  V <- A
  V.Count = A.Count - ACount
}
function BN_Decrease (var V: T_BNX; const A: T_BNX; ACount: IntX): IntX;
var
  I      : LoopInt;
  VCount : IntX;
begin
  if ACount = 0 then begin
    Result := BN_copy (V, A);
    Exit;
  end;

  VCount := A.Count - ACount;
  if VCount <= 0 then begin
    Result := BN_AssignZero (V);
    Exit;
  end;

  Result := BN_Alloc (V, A.Sign, VCount);
  if ACount > 0 then begin
    // A.Count > VCount
    BN_CopyData (V.PLData, A.PLData, VCount);
  end else begin
    // A.Count < VCount
    BN_CopyData (V.PLData, A.PLData, A.Count);
    for I := A.Count to V.HIndex do V.Data[I] := 0;
  end;
end;

{
   
  Signed comparison

  Result
  V1 = V2 :  0
  V1 > V2 : +1
  V1 < V2 : -1
}
function BN_Compare (const V1, V2: T_BNX): Integer;
var
  VSign1 : IntX;
  VSign2 : IntX;
begin
  VSign1 := V1.Sign;
  VSign2 := V2.Sign;

  if (VSign1 = 0) then begin
    // V1 = 0
    // 0 =  0 |  0
    // 0 < +1 | -1
    // 0 > -1 | +1
    Result := -VSign2;
    Exit;
  end;

  if (VSign2 = 0) then begin
    // V2 = 0
    //  0 = 0 |  0
    // +1 > 0 | +1
    // -1 < 0 | -1
    Result := VSign1;
    Exit;
  end;

  Result := BN_DataCompare (V1, V2);

  if Result > 0 then begin
    // |V1| > |V2|
    // +2 > +1 | +1
    // +2 > -1 | +1
    // -2 < +1 | -1
    // -2 < -1 | -1
    Result := VSign1;
    Exit;
  end;

  if Result < 0 then begin
    // |V1| < |V2|
    // +1 < +2 | -1
    // -1 < +2 | -1
    // +1 > -2 | +1
    // -1 > -2 | +1
    Result := -VSign2;
    Exit;
  end;

  // |V1| = |V2|
  // +2 = +2 |  0
  // +2 > -2 | +1
  // -2 < +2 | -1
  // -2 = -2 |  0
  if VSign1 <> VSign2 then begin
    Result := VSign1;
  end;
end;

// [+] 1.2.1
{
   
  Signed comparison

  Result
  V1 = V2 :  0
  V1 > V2 : +1
  V1 < V2 : -1
}
function BN_Compare (const V1: T_BNX; V2: IntX): Integer;
var
  VSign1 : IntX;
  VSign2 : IntX;
begin
  VSign1 := V1.Sign;

  VSign2 := 0;
  if V2 > 0 then VSign2 := +1 else
  if V2 < 0 then VSign2 := -1 ;
  V2 := abs (V2);

  if (VSign1 = 0) then begin
    // V1 = 0
    // 0 =  0 |  0
    // 0 < +1 | -1
    // 0 > -1 | +1
    Result := -VSign2;
    Exit;
  end;

  if (VSign2 = 0) then begin
    // V2 = 0
    //  0 = 0 |  0
    // +1 > 0 | +1
    // -1 < 0 | -1
    Result := VSign1;
    Exit;
  end;

  Result := BN_DataCompare (V1, V2);

  if Result > 0 then begin
    // |V1| > |V2|
    // +2 > +1 | +1
    // +2 > -1 | +1
    // -2 < +1 | -1
    // -2 < -1 | -1
    Result := VSign1;
    Exit;
  end;

  if Result < 0 then begin
    // |V1| < |V2|
    // +1 < +2 | -1
    // -1 < +2 | -1
    // +1 > -2 | +1
    // -1 > -2 | +1
    Result := -VSign2;
    Exit;
  end;

  // |V1| = |V2|
  // +2 = +2 |  0
  // +2 > -2 | +1
  // -2 < +2 | -1
  // -2 = -2 |  0
  if VSign1 <> VSign2 then begin
    Result := VSign1;
  end;
end;

// [+] 1.2.1
{
   
  Signed comparison

  Result
  V1 = V2 :  0
  V1 > V2 : +1
  V1 < V2 : -1
}
function BN_Compare (const V1: T_BNX; ASign2: ShortInt; V2: UIntX): Integer;
var
  VSign1 : IntX;
begin
  VSign1 := V1.Sign;

  if (VSign1 = 0) then begin
    // V1 = 0
    // 0 =  0 |  0
    // 0 < +1 | -1
    // 0 > -1 | +1
    Result := -ASign2;
    Exit;
  end;

  if (ASign2 = 0) then begin
    // V2 = 0
    //  0 = 0 |  0
    // +1 > 0 | +1
    // -1 < 0 | -1
    Result := VSign1;
    Exit;
  end;

  Result := BN_DataCompare (V1, V2);

  if Result > 0 then begin
    // |V1| > |V2|
    // +2 > +1 | +1
    // +2 > -1 | +1
    // -2 < +1 | -1
    // -2 < -1 | -1
    Result := VSign1;
    Exit;
  end;

  if Result < 0 then begin
    // |V1| < |V2|
    // +1 < +2 | -1
    // -1 < +2 | -1
    // +1 > -2 | +1
    // -1 > -2 | +1
    Result := -ASign2;
    Exit;
  end;

  // |V1| = |V2|
  // +2 = +2 |  0
  // +2 > -2 | +1
  // -2 < +2 | -1
  // -2 = -2 |  0
  if VSign1 <> ASign2 then begin
    Result := VSign1;
  end;
end;

{
}
function BNX_DataCompare (const V1, V2; Count: IntX): Integer;
{$IFDEF CPUX64}
// rcx | V1
// rdx | V2
// r8  | Count
asm
       .NOFRAME

        xor     rax, rax

        dec     r8
        jl      @r // Count <= 0
    @loop:
        mov     r9, [rcx]
        cmp     r9, [rdx]
        ja      @a
        jb      @b
        lea     rcx, [rcx - CXBytes]
        lea     rdx, [rdx - CXBytes]
        dec     r8
        jge     @loop
        jmp     @r
    @a: inc     rax
        jmp     @r
    @b: dec     rax
    @r:
end;
{$ELSE}
// eax | V1    | ebx
// edx | V2    |
// ecx | Count |
asm
        push    ebx
        push    esi

        mov     ebx, eax
        xor     eax, eax

        dec     ecx
        jl      @r // Count <= 0
    @loop:
        mov     esi, [ebx]
        cmp     esi, [edx]
        ja      @a
        jb      @b
        lea     ebx, [ebx - CXBytes]
        lea     edx, [edx - CXBytes]
        dec     ecx
        jge     @loop
        jmp     @r
    @a: inc     eax
        jmp     @r
    @b: dec     eax
    @r:
        pop     esi
        pop     ebx
end;
{$ENDIF}

{
   
  Unsigned comparison

  Result
  V1.Data = V2.Data :  0
  V1.Data > V2.Data : +1
  V1.Data < V2.Data : -1
}
function BN_DataCompare (const V1, V2: T_BNX): Integer;
var
  I       : IntX;
  VCount1 : IntX;
  VCount2 : IntX;
begin
  VCount1 := BN_DataCount (V1);
  VCount2 := BN_DataCount (V2);

  if VCount1 > VCount2 then begin
    Result := +1;
    Exit;
  end;

  if VCount1 < VCount2 then begin
    Result := -1;
    Exit;
  end;

  // VCount1 = VCount2

  I := VCount1 - 1;
  Result := BNX_DataCompare (V1.Data[I], V2.Data[I], VCount1);
end;

{
   
  Unsigned comparison

  Result
  V1.Data = V2.Data :  0
  V1.Data > V2.Data : +1
  V1.Data < V2.Data : -1
}
function BN_DataCompare_(const V1, V2: T_BNX): Integer;
var
  I       : LoopInt;
  VCount1 : IntX;
  VCount2 : IntX;
  VValue1 : UIntX;
  VValue2 : UIntX;
begin
  Result := 0;

  VCount1 := BN_DataCount (V1);
  VCount2 := BN_DataCount (V2);

  if VCount1 > VCount2 then begin
    Result := +1;
    Exit;
  end;

  if VCount1 < VCount2 then begin
    Result := -1;
    Exit;
  end;

  // VCount1 = VCount2

  for I := VCount1 - 1 downto 0 do begin
    VValue1 := V1.Data[I];
    VValue2 := V2.Data[I];
    if VValue1 > VValue2 then begin
      Result := +1;
      Exit;
    end;
    if VValue1 < VValue2 then begin
      Result := -1;
      Exit;
    end;
  end;
end;

{
   
  Unsigned comparison

  Result
  V1.Data = V2 :  0
  V1.Data > V2 : +1
  V1.Data < V2 : -1
}
function BN_DataCompare (const V1: T_BNX; V2: UIntX): Integer;
var
  VCount1 : IntX;
  VValue1 : UIntX;
begin
  Result := 0;

  VCount1 := BN_DataCount (V1);

  if VCount1 <= 0 then begin
    // |V1|  = 0
    // |V2|  = 0 | 0
    // |V2| != 0 | -1
    if V2 <> 0 then Result := -1;
    Exit;
  end;

  // |V1| != 0

  if (VCount1 > 1) or (V2 = 0) then begin
    Result := +1;
    Exit;
  end;

  // VCount1 = 1

  VValue1 := V1.Data[0];
  if VValue1 > V2 then begin
    Result := +1;
    Exit;
  end;
  if VValue1 < V2 then begin
    Result := -1;
    Exit;
  end;
end;

// [+] 1.2.1
{
}
function BN_IsPowerOfTwo (const A: T_BNX): Boolean;
var
  V_bsf : IntX;
  V_bsr : IntX;
begin
  Result := false;
  if BN_IsZero (A) then Exit;

  V_bsf := BN_bsf (A);
  V_bsr := BN_bsr (A);
  Result := V_bsf = V_bsr;
end;

// [+] 1.2.1
{
}
function BN_IsPowerOfTwo (const A: UIntX): Boolean;
var
  V_bsf : IntX;
  V_bsr : IntX;
begin
  Result := false;
  if A = 0 then Exit;

  V_bsf := bsf (A);
  V_bsr := bsr (A);
  Result := V_bsf = V_bsr;
end;

// [+] 1.2.1
{
}
function BN_IsPowerOfTwo (const A: T_BNX; var ABit: IntX): Boolean;
var
  V_bsf : IntX;
  V_bsr : IntX;
begin
  ABit := -1;
  Result := false;

  if BN_IsZero (A) then Exit;

  V_bsf := BN_bsf (A);
  V_bsr := BN_bsr (A);
  Result := V_bsf = V_bsr;
  if Result then ABit := V_bsf;
end;

// [+] 1.2.1
{
}
function BN_IsPowerOfTwo (const A: UIntX; var ABit: IntX): Boolean;
var
  V_bsf : IntX;
  V_bsr : IntX;
begin
  ABit := -1;
  Result := false;

  if A = 0 then Exit;

  V_bsf := bsf (A);
  V_bsr := bsr (A);
  Result := V_bsf = V_bsr;
  if Result then ABit := V_bsf;
end;

// [+] 1.2.1
{
}
function BN_AsInt (const V: T_BNX): UIntX;
var
  VCount : IntX;
begin
  VCount := BN_DataCount (V);
  if VCount <= 0 then begin
    Result := 0;
    Exit;
  end;

  Result := V.Data[0];
end;

// [+] 1.2.1
{
}
function BN_AsInt (const V: T_BNX; var ASign: ShortInt): UIntX;
var
  VCount : IntX;
begin
  VCount := BN_DataCount (V);
  if VCount <= 0 then begin
    ASign := 0;
    Result := 0;
    Exit;
  end;

  ASign := V.Sign;
  Result := V.Data[0];
end;

{
  ?  
  ? Odd number
}
function BN_IsOdd (const V: T_BNX): Boolean;
var
  VCount : IntX;
begin
  VCount := BN_DataCount (V);
  if (V.Sign = 0) or (VCount <= 0) then begin
    Result := false; // 0 is even
    Exit;
  end;

  Result := Odd (V.Data[0]);
end;

{
  ? ׸ 
  ? Even number
}
function BN_IsEven (const V: T_BNX): Boolean;
var
  VCount : IntX;
begin
  VCount := BN_DataCount (V);
  if (V.Sign = 0) or (VCount <= 0) then begin
    Result := true; // 0 is even
    Exit;
  end;

  Result := not Odd (V.Data[0]);
end;

// [+] 1.2.1
{
  V = min(A,B)
}
function BN_Min (var V: T_BNX; const A, B: T_BNX): Integer;
begin
  if BN_Compare (A, B) < 0 then begin
    Result := BN_copy (V, A);
  end else begin
    Result := BN_copy (V, B);
  end;
end;

// [+] 1.2.1
{
  V = max(A,B)
}
function BN_Max (var V: T_BNX; const A, B: T_BNX): Integer;
begin
  if BN_Compare (A, B) > 0 then begin
    Result := BN_copy (V, A);
  end else begin
    Result := BN_copy (V, B);
  end;
end;

// [+] 1.2.1
{
  V = min(|A|,|B|)
}
function BN_AbsMin (var V: T_BNX; const A, B: T_BNX): Integer;
begin
  if BN_DataCompare (A, B) < 0 then begin
    Result := BN_acopy (V, A);
  end else begin
    Result := BN_acopy (V, B);
  end;
end;

// [+] 1.2.1
{
  V = max(|A|,|B|)
}
function BN_AbsMax (var V: T_BNX; const A, B: T_BNX): Integer;
begin
  if BN_DataCompare (A, B) > 0 then begin
    Result := BN_acopy (V, A);
  end else begin
    Result := BN_acopy (V, B);
  end;
end;

// [+] 1.2.1
{
  Get a perfect square number V greater than the initial value of V
}
function BN_GetGPSquare (var V: T_BNX; ABreak: PBoolean = nil): Boolean;
var
  V_SQRT : T_BNX;
  V_rem  : T_BNX;
  U      : T_BNX;
begin
  Result := true;

  if BN_LT_Zero (V) then begin
    BN_AssignZero (V);
    Exit;
  end;

  try
    while true do begin
      if Break_(ABreak) then begin
        Result := false;
        Exit;
      end;

      BN_inc_(V, U);
      if BN_ppsqr (V) then begin
        BN_sqrt_rem (V_SQRT, V_rem, V);
        if BN_IsZero (V_rem) then Exit;
      end;
    end;
  finally
    BN_LFree (V_SQRT);
    BN_LFree (V_rem);
    BN_LFree (U);
  end;
end;

// [+] 1.2.1
{
  Get a perfect square number V less than the initial value of V
}
function BN_GetLPSquare (var V: T_BNX; ABreak: PBoolean = nil): Boolean;
var
  V_SQRT : T_BNX;
  V_rem  : T_BNX;
  U      : T_BNX;
begin
  Result := true;

  if BN_LT_Zero (V) then begin
    Result := false;
    Exit;
  end;

  try
    while true do begin
      if Break_(ABreak) then begin
        Result := false;
        Exit;
      end;

      BN_dec_(V, U);
      if BN_ppsqr (V) then begin
        BN_sqrt_rem (V_SQRT, V_rem, V);
        if BN_IsZero (V_rem) then Exit;
      end;
    end;
  finally
    BN_LFree (V_SQRT);
    BN_LFree (V_rem);
    BN_LFree (U);
  end;
end;

// [+] 1.2.1
{
  Get a co-prime to A number greater than the initial value of V
  Returns result in V
}
function BN_GetGCoPrime (var V: T_BNX; const A: T_BNX): Boolean;
var
  D : UIntX;
  G : T_BNX;
  U : T_BNX;
begin
  Result := true;

  try
    if BN_IsOdd (A) then begin
      D := 1;
      BN_inc_(V, U);                // V: 26 -> 27, 28, ...
    end else begin
      D := 2;
      if BN_IsOdd (V) then begin
        BN_add_int_(V, 1, D, U);    // V: 25 -> 27, 29, ...
      end else begin
        BN_inc_(V, U);              // V: 26 -> 27, 29, ...
      end;
    end;

    while true do begin
      BN_gcd (G, V, A);
      if BN_IsOne (G) then Exit;

      BN_add_int_(V, 1, D, U);
    end;
  finally
    BN_LFree (G);
    BN_LFree (U);
  end;
end;

// [+] 1.2.1
{
  Get a co-prime to A number less than the initial value of V
  Returns result in V
}
function BN_GetLCoPrime (var V: T_BNX; const A: T_BNX): Boolean;
var
  D : UIntX;
  G : T_BNX;
  U : T_BNX;
begin
  Result := true;

  try
    if BN_IsOdd (A) then begin
      D := 1;
      BN_dec_(V, U);                // V: 24 -> 23, 22, ...
    end else begin
      D := 2;
      if BN_IsOdd (V) then begin
        BN_sub_int_(V, 1, D, U);    // V: 25 -> 23, 21, ...
      end else begin
        BN_dec_(V, U);              // V: 24 -> 23, 21, ...
      end;
    end;

    while true do begin
      BN_gcd (G, V, A);
      if BN_IsOne (G) then Exit;

      BN_sub_int_(V, 1, D, U);
    end;
  finally
    BN_LFree (G);
    BN_LFree (U);
  end;
end;

// [+] 1.2.1
{
  Get a prime number V greater than the initial value of V
}
function BN_GetGPrime (var V: T_BNX; R: Integer = 64;
  ABreak: PBoolean = nil): Boolean;
var
  U : T_BNX;
begin
  Result := true;

  if BN_Compare (V, 1, 1) <= 0 then begin // V <= 1
    BN_AssignInt (V, 1, 2); // V = 2
    Exit;
  end;

  try
    if BN_IsEven (V) then BN_dec_(V, U);

    while true do begin
      if Break_(ABreak) then begin
        Result := false;
        Exit;
      end;

      BN_add_int_(V, 1, 2, U);
      if BN_PrimeTest (V, R, ABreak) then Exit;
    end;
  finally
    BN_LFree (U);
  end;
end;

// [+] 1.2.1
{
  Get a prime number V less than the initial value of V
}
function BN_GetLPrime (var V: T_BNX; R: Integer = 64;
  ABreak: PBoolean = nil): Boolean;
var
  U : T_BNX;
begin
  Result := true;

  if BN_Compare (V, 1, 2) <= 0 then begin // V <= 2
    Result := false;
    Exit;
  end;

  try
    if BN_IsEven (V) then BN_inc_(V, U);

    while true do begin
      if Break_(ABreak) then begin
        Result := false;
        Exit;
      end;

      BN_sub_int_(V, 1, 2, U);
      if BN_PrimeTest (V, R, ABreak) then Exit;
    end;
  finally
    BN_LFree (U);
  end;
end;

// [+] 1.2.1
{
  Generate a random ABits-bit prime number V
}
function BN_GenPrime (var V: T_BNX; ABits: UIntX; R: Integer = 64;
  ABreak: PBoolean = nil): Boolean;
var
  V0     : T_BNX;
  U      : T_BNX;
  VCount : IntX;
begin
  Result := true;

  VCount := cdiv (ABits, CXBits);
  if VCount = 0 then begin
    Result := false;
    BN_AssignZero (V);
    Exit;
  end;

  BN_Alloc (V, VCount);
  BN_Randomize;
  BN_Random (V);
  V.Data[0] := V.Data[0] or 1; // make V odd

  if BN_PrimeTest (V, R, ABreak) then Exit;

  try
    BN_copy (V0, V); // save initial random value

    // test odd numbers that are greater than V0
    while true do begin
      if Break_(ABreak) then begin
        Result := false;
        Exit;
      end;

      BN_add_int_(V, 1, 2, U);
      if V.Count > VCount then Break;

      if BN_PrimeTest (V, R, ABreak) then Exit;
    end;

    BN_copy (V, V0); // restore initial random value

    // test odd numbers that are less than V0
    while true do begin
      if Break_(ABreak) then begin
        Result := false;
        Exit;
      end;

      BN_sub_int_(V, 1, 2, U);
      if BN_PrimeTest (V, R, ABreak) then Exit;
    end;
  finally
    BN_LFree (V0);
    BN_LFree (U);
  end;
end;

// [+] 1.2.1
{
  Generate a random ABits-bit prime number V
  The number (V-1)/2 also is a prime
}
function BN_GenPrime_DH (var V: T_BNX; ABits: UIntX; R: Integer = 64;
  ABreak: PBoolean = nil): Boolean;
var
  V0     : T_BNX;
  U      : T_BNX;
  VCount : IntX;

  function main_proc_(): Boolean;
  begin
    Result := true;

    BN_Alloc (V, VCount);
    BN_Randomize;
    BN_Random (V);
    V.Data[0] := V.Data[0] or 1; // make V odd

    BN_copy (V0, V); // save initial random value

    // test odd numbers that are greater than V0
    while true do begin
      if Break_(ABreak) then begin
        Result := false;
        Exit;
      end;

      BN_add_int_(V, 1, 2, U);
      if V.Count > VCount then Break;

      if BN_PrimeTest (V, R, ABreak) then Exit;
    end;

    BN_copy (V, V0); // restore initial random value

    // test odd numbers that are less than V0
    while true do begin
      if Break_(ABreak) then begin
        Result := false;
        Exit;
      end;

      BN_sub_int_(V, 1, 2, U);
      if BN_PrimeTest (V, R, ABreak) then Exit;
    end;
  end;

begin
  Result := false;

  VCount := cdiv (ABits, CXBits);
  if VCount = 0 then begin
    BN_AssignZero (V);
    Exit;
  end;

  try
    while true do begin
      Result := main_proc_();
      if not Result then Exit;

      if Break_(ABreak) then begin
        Result := false;
        Exit;
      end;

      BN_dec (U, V); // U = (V-1)
      BN_shr_1 (U);  // U = (V-1)/2
      Result := BN_PrimeTest (U, R, ABreak);
      if Result then Exit;
      if Break_(ABreak) then Exit;
    end;
  finally
    BN_LFree (V0);
    BN_LFree (U);
  end;
end;

// [+] 1.2.1
{
  Generate a random ABits-bit prime number V
  Use Blum-Blum-Shub random generator
}
function BN_GenPrime_BBS (var V: T_BNX; ABits: UIntX; R: Integer = 64;
  ABreak: PBoolean = nil): Boolean;
var
  V0     : T_BNX;
  U      : T_BNX;
  VCount : IntX;
begin
  Result := true;

  VCount := cdiv (ABits, CXBits);
  if VCount = 0 then begin
    Result := false;
    BN_AssignZero (V);
    Exit;
  end;

  BN_Alloc (V, VCount);
  BN_BBS_Random (V);
  V.Data[0] := V.Data[0] or 1; // make V odd

  if BN_PrimeTest (V, R, ABreak) then Exit;

  try
    BN_copy (V0, V); // save initial random value

    // test odd numbers that are greater than V0
    while true do begin
      if Break_(ABreak) then begin
        Result := false;
        Exit;
      end;

      BN_add_int_(V, 1, 2, U);
      if V.Count > VCount then Break;

      if BN_PrimeTest (V, R, ABreak) then Exit;
    end;

    BN_copy (V, V0); // restore initial random value

    // test odd numbers that are less than V0
    while true do begin
      if Break_(ABreak) then begin
        Result := false;
        Exit;
      end;

      BN_sub_int_(V, 1, 2, U);
      if BN_PrimeTest (V, R, ABreak) then Exit;
    end;
  finally
    BN_LFree (V0);
    BN_LFree (U);
  end;
end;

// [+] 1.2.1
{
  Generate a random V ABits-bit prime number
  V = 3 (mod 4)
}
function BN_GenPrime_3m4 (var V: T_BNX; ABits: UIntX; R: Integer = 64;
  ABreak: PBoolean = nil): Boolean;
var
  V0     : T_BNX;
  U      : T_BNX;
  VCount : IntX;
begin
  Result := true;

  VCount := cdiv (ABits, CXBits);
  if VCount = 0 then begin
    Result := false;
    BN_AssignZero (V);
    Exit;
  end;

  BN_Alloc (V, VCount);
  BN_Randomize;
  BN_Random (V);
  V.Data[0] := V.Data[0] or 3; // make V odd and V = 3 (mod 4)

  if BN_PrimeTest (V, R, ABreak) then Exit;

  try
    BN_copy (V0, V); // save initial random value

    // test odd numbers that are greater than V0
    while true do begin
      if Break_(ABreak) then begin
        Result := false;
        Exit;
      end;

      BN_add_int_(V, 1, 4, U);
      if V.Count > VCount then Break;

      if BN_PrimeTest (V, R, ABreak) then Exit;
    end;

    BN_copy (V, V0); // restore initial random value

    // test odd numbers that are less than V0
    while true do begin
      if Break_(ABreak) then begin
        Result := false;
        Exit;
      end;

      BN_sub_int_(V, 1, 4, U);
      if BN_PrimeTest (V, R, ABreak) then Exit;
    end;
  finally
    BN_LFree (V0);
    BN_LFree (U);
  end;
end;

// [+] 1.2.1
{
    
  Primality test

  R -  
  R - round count

   TRUE,  n -   
  Returns TRUE if n is probably prime number

   FALSE,  n -  
  Returns FALSE if n is composite number
}
function BN_PrimeTest (const n: T_BNX; R: Integer = 64;
  ABreak: PBoolean = nil): Boolean;
var
  I : Integer;
  D : UIntX;
  P : UIntX;
  U : UIntX;
  V : T_BNX;
begin
  Result := false;

  if BN_DataCompare (n, 2) = 0 then begin
    Result := true; // |n| = 2
    Exit;
  end;

  if BN_IsEven (n) then Exit;
  if BN_IsOne (n) then Exit;

  try
    //  
    // Trial division
    if BN_IsInt (n, D) then begin
      for I := 1 to HIGH(CPrimes) do begin // CPrimes = 3, 5, ...
        P := CPrimes[I];
        if P > D then Break;

        if P = D then begin
          Result := true;
          Exit;
        end;

        U := D mod P;
        if U = 0 then Exit;
      end;
    end else begin
      for I := 1 to HIGH(CPrimes) do begin // CPrimes = 3, 5, ...
        P := CPrimes[I];
        U := BN_div_mod_int (V, n, 1, P, false);
        if U = 0 then Exit;
      end;
    end;

    //  -
    // MillerRabin primality test
    Result := BN_PrimeTest_Miller_Rabin (n, R, ABreak);
  finally
    BN_LFree (V);
  end;
end;

// [+] 1.2.1
{
   -
  MillerRabin primality test

  R -  
  R - round count

   TRUE,  n -   
  Returns TRUE if n is probably prime number

   FALSE,  n -  
  Returns FALSE if n is composite number
}
function BN_PrimeTest_Miller_Rabin (const n: T_BNX; R: Integer = 64;
  ABreak: PBoolean = nil): Boolean;
var
  V_mask : UIntX;

  // 2 < A_R < n-1
  procedure Random_(var A_R: T_BNX);
  begin
    while true do begin
      BN_Random (A_R);

      // clear upper bits to make A_R < n-1
      A_R.PHData^ := A_R.PHData^ and V_mask;
      if BN_Pack (A_R) > 1 then Exit;

      if BN_Compare (A_R, 1, 2) > 0 then Exit;
    end;
  end;

var
  I     : LoopInt;
  J     : LoopInt;
  C     : IntX;
  V_shr : IntX;
  V_S   : UIntX;
  V_n   : T_BNX;
  V_nmo : T_BNX;
  V_t   : T_BNX;
  V_a   : T_BNX;
  V_x   : T_BNX;
  V_u   : T_BNX;
  V_pp  : Boolean; // probably prime
begin
  Result := false;

  if BN_DataCompare (n, 2) = 0 then begin
    Result := true; // |n| = 2
    Exit;
  end;

  if BN_IsEven (n) then Exit;
  if BN_IsOne (n) then Exit;

  try
    BN_acopy (V_n, n); // n = |n|

    // n = (2^s)*t + 1
    BN_dec (V_nmo, V_n); // nmo = n-1
    V_S := BN_m2n_(V_nmo, V_t);

    V_shr := CXBits - bsr (V_nmo.PHData^);
    V_mask := 0;
    if V_shr < CXBits then V_mask := CXmask shr V_shr;

    C := V_nmo.Count;
    BN_Alloc (V_a, C);

    BN_Randomize;

    for I := 1 to R do begin
      if Break_(ABreak) then Exit;

      BN_Resize (V_a, C);
      Random_(V_a);

      BN_pow_mod_mon (V_x, V_a, V_t, V_n);
      // x = a^t mod n

      if BN_IsOne (V_x) then Continue; // x = 1
      if BN_DataCompare (V_x, V_nmo) = 0 then Continue; // x = n-1

      V_pp := false;
      for J := 1 to V_S - 1 do begin
        if Break_(ABreak) then Exit;

        BN_sqr (V_u, V_x);
        BN_mod (V_x, V_u, V_n);
        // x = x^2 mod n

        if BN_IsOne (V_x) then Exit; // x = 1
        if BN_DataCompare (V_x, V_nmo) = 0 then begin // x = n-1
          V_pp := true;
          Break;
        end;
      end;
      if not V_pp then Exit;
    end;

    Result := true;
  finally
    BN_LFree (V_n);
    BN_LFree (V_nmo);
    BN_LFree (V_t);
    BN_LFree (V_a);
    BN_LFree (V_x);
    BN_LFree (V_u);
  end;
end;

// [+] 1.2.1
{
  RSA test

  e = 65537
  p = input
  q = *
}
function BN_RSATest (const p: T_BNX): Boolean;
var
  V_shr  : IntX;
  V_mask : UIntX;
  V_p    : T_BNX;
  V_pmo  : T_BNX;
  V_q    : T_BNX;
  V_qmo  : T_BNX;
  V_n    : T_BNX;
  V_phi  : T_BNX;
  V_e    : T_BNX;
  V_d    : T_BNX;
  V_enc  : T_BNX;
  V_dec  : T_BNX;
begin
  Result := false;
  if BN_IsZero (p) then Exit;

  try
    BN_acopy (V_p, p); // p = |p|

    {$IFDEF CPUX64}
    BN_AssignInt (V_q, 1, 99194853094755497); // Prime Fibonacci number #12
    {$ELSE}
    BN_AssignInt (V_q, 1, 2971215073);        // Prime Fibonacci number #11
    {$ENDIF}

    // q = some prime number
    // p = number to test

    BN_mul (V_n, V_p, V_q);       // n = p*q
    BN_dec (V_pmo, V_p);
    BN_dec (V_qmo, V_q);
    BN_mul (V_phi, V_pmo, V_qmo); // phi = (p-1)*(q-1)

    BN_AssignInt (V_e, 1, 65537); // e = 65537
    BN_inv_mod (V_d, V_e, V_phi); // d*e mod phi = 1

    // (e,n) - RSA public key
    // (d,n) - RSA private key

    // generate random p < n
    BN_Random (V_p, V_n.Count);
    if V_p.Count = V_n.Count then begin
      V_shr := CXBits - bsr (V_n.PHData^);
      V_mask := 0;
      if V_shr < CXBits then V_mask := CXmask shr V_shr;

      // clear upper bits to make p < n
      V_p.PHData^ := V_p.PHData^ and V_mask;
      BN_Pack (V_p);
    end;

    BN_pow_mod_mon (V_enc, V_p, V_e, V_n);   // enc = (?^e) mod n
    BN_pow_mod_mon (V_dec, V_enc, V_d, V_n); // dec = (?^d) mod n

    Result := BN_Compare (V_p, V_dec) = 0;
  finally
    BN_LFree (V_p);
    BN_LFree (V_pmo);
    BN_LFree (V_q);
    BN_LFree (V_qmo);
    BN_LFree (V_n);
    BN_LFree (V_phi);
    BN_LFree (V_e);
    BN_LFree (V_d);
    BN_LFree (V_enc);
    BN_LFree (V_dec);
  end;
end;

// [+] 1.2.1
{
  DiffieHellman key exchange test
}
function BN_DHTest (const g: T_BNX): Boolean;
var
  V_g   : T_BNX;
  V_p   : T_BNX;
  V_a   : T_BNX;
  V__A  : T_BNX;
  V_b   : T_BNX;
  V__B  : T_BNX;
  V_K_a : T_BNX;
  V_K_b : T_BNX;
begin
  Result := false;
  if BN_IsZero (g) then Exit;

  try
    BN_acopy (V_g, g); // g = |g|
    BN_GenPrime_DH (V_p, 64, 16);

    // p = some prime number
    // g = number to test

    BN_Alloc (V_a, 16);
    BN_Alloc (V_b, 16);

    BN_Random (V_a);
    BN_Random (V_b);

    // a, b - private values

    BN_pow_mod_mon (V__A, V_g, V_a, V_p); // A = (g^a) mod p
    BN_pow_mod_mon (V__B, V_g, V_b, V_p); // B = (g^b) mod p

    // p, g, A, B - public values

    BN_pow_mod_mon (V_K_a, V__B, V_a, V_p); // K(a) = (B^a) mod p = (g^(a*b)) mod p
    BN_pow_mod_mon (V_K_b, V__A, V_b, V_p); // K(b) = (A^b) mod p = (g^(a*b)) mod p

    // K - secret key

    Result := BN_Compare (V_K_a, V_K_b) = 0;
  finally
    BN_LFree (V_g);
    BN_LFree (V_p);
    BN_LFree (V_a);
    BN_LFree (V__A);
    BN_LFree (V_b);
    BN_LFree (V__B);
    BN_LFree (V_K_a);
    BN_LFree (V_K_b);
  end;
end;

// [+] 1.2.1
{
    
  Fermat's factorization method

  n = x^2 - y^2
  n > 0
}
function BN_Factor_Fermat (var p, q: T_BNX; const n: T_BNX;
  ABreak: PBoolean = nil): Integer;
var
  V_SQRT : T_BNX;
  V_rem  : T_BNX;
  V_x0   : T_BNX;
  V_x0n  : T_BNX;
  V_y    : T_BNX;
  V_y_k  : T_BNX;
  V_k    : T_BNX;
  V_2k   : T_BNX;
  V, U   : T_BNX;
begin
  Result := 0;

  if BN_LE_Zero (n) then begin
    BN_AssignZero (p); // p = 0
    BN_AssignZero (q); // q = 0
    Exit;
  end;

  if BN_DataCompare (n, 3) <= 0 then begin // |n| <= 3
    BN_AssignPOne (p); // p = 1
    BN_copy (q, n);    // q = n
    Result := 1;
    Exit;
  end;

  try
    BN_sqrt_rem (V_SQRT, V_rem, n);

    if BN_IsZero (V_rem) then begin // n is perfect square
      BN_copy (p, V_SQRT); // p = SQRT(n)
      BN_copy (q, V_SQRT); // q = SQRT(n)
      Result := 2;
      Exit;
    end;

    BN_inc (V_x0, V_SQRT);
    // x0^2 - n > 0

    // y(k)   = (x0 + k)^2 - n
    //        = x0^2 + 2*x0*k + k^2 - n
    // y(k+1) = x0^2 + 2*x0*k + 2*x0 + k^2 + 2*k + 1 - n
    //        = y(k) + (2*x0 + 1) + 2*k

    BN_shl_1 (V, V_x0); // 2*x0
    BN_inc (V_x0n, V);  // 2*x0 + 1
    // x0n = 2*x0 + 1

    BN_sqr (V, V_x0);     // x0^2
    BN_sub (V_y_k, V, n); // x0^2 - n
    // y_k = (x0 + 0)^2 - n, k=0

    BN_AssignZero (V_k);
    BN_AssignZero (V_2k);

    while true do begin
      if Break_(ABreak) then Exit;

      if BN_ppsqr (V_y_k) then begin
        BN_sqrt_rem (V_y, V_rem, V_y_k);
        if BN_IsZero (V_rem) then begin // y(k) is perfect square
          // x^2 - n = y^2
          BN_add (V, V_y_k, n); // y^2 + n
          BN_sqrt (U, V);       // x
          BN_sub (p, U, V_y);   // x - y
          BN_add (q, U, V_y);   // x + y
          Result := 1;
          Exit;
        end;
      end;

      BN_add (U, V_y_k, V_x0n); // y(k) + (2*x0 + 1)
      BN_add (V_y_k, U, V_2k);  // y(k) + (2*x0 + 1) + 2*k
      // y(k+1) = y(k) + (2*x0 + 1) + 2*k

      BN_inc (U, V_k);
      BN_copy (V_k, U);
      BN_shl_1 (V_2k, V_k);  // 2*k
    end;

  finally
    BN_LFree (V_SQRT);
    BN_LFree (V_rem);
    BN_LFree (V_x0);
    BN_LFree (V_x0n);
    BN_LFree (V_y);
    BN_LFree (V_y_k);
    BN_LFree (V_k);
    BN_LFree (V_2k);
    BN_LFree (V);
    BN_LFree (U);
  end;
end;

// [+] 1.2.1
{
  Useless function
  n = x^2m - y^2m
}
function BN_Factor_Fermat_2m (var p, q: T_BNX; const n: T_BNX; m: UIntX;
  ABreak: PBoolean = nil): Integer;
var
  C      : Integer;
  V_2m   : UIntX;
  V_ROOT : T_BNX;
  V_rem  : T_BNX;
  V_x0   : T_BNX;
  V_y    : T_BNX;
  V_y_k  : T_BNX;
  V, U   : T_BNX;
begin
  Result := 0;

  if BN_LE_Zero (n) then begin
    BN_AssignZero (p); // p = 0
    BN_AssignZero (q); // q = 0
    Exit;
  end;

  if BN_DataCompare (n, 3) <= 0 then begin // |n| <= 3
    BN_AssignPOne (p); // p = 1
    BN_copy (q, n);    // q = n
    Result := 1;
    Exit;
  end;

  try
    V_2m := 2*m;
    BN_root_rem (V_ROOT, V_rem, n, V_2m);

    (*
    if BN_Compare (V_ROOT, 1, 1) <= 0 then begin
      BN_AssignZero (p); // p = 0
      BN_AssignZero (q); // q = 0
      Result := -1;
      Exit;
    end;
    // *)

    if BN_IsZero (V_rem) then begin // n is perfect power
      BN_copy (p, V_ROOT); // p = ROOT(n)
      BN_copy (q, V_ROOT); // q = ROOT(n)
      Result := 2;
      Exit;
    end;

    BN_inc (V_x0, V_ROOT);
    // x0^2m - n > 0
    // y(k) = (x0 + k)^2m - n

    BN_pow (V, V_x0, V_2m); // x(k)^2m
    BN_sub (V_y_k, V, n);   // x(k)^2m - n
    // y_k = (x0 + 0)^2m - n, k=0

    C := 0;
    while true do begin
      if Break_(ABreak) then Exit;

      if BN_ppp2m (V_y_k, m) then begin
        C := 0;
        BN_root_rem (V_y, V_rem, V_y_k, V_2m);
        if BN_IsZero (V_rem) then begin // y(k) is perfect power
          // x^2m - n = y^2m
          // (x^m)^2 - (y^m)^2 = n
          // (x^m - y^m)*(x^m + y^m) = n
          BN_add (V, V_y_k, n); // y^2m + n
          BN_sqrt (U, V);       // x^m
          BN_sqrt (V, V_y);     // y^m
          BN_sub (p, U, V_y);   // x^m - y^m
          BN_add (q, U, V_y);   // x^m + y^m
          Result := 1;
          Exit;
        end;
      end;

      BN_inc_(V_x0, V);       // k + 1
      BN_pow (V, V_x0, V_2m); // x(k)^2m
      BN_sub (V_y_k, V, n);   // x(k)^2m - n

      Inc (C);
      if C > 255 then begin
        BN_AssignZero (p); // p = 0
        BN_AssignZero (q); // q = 0
        Result := -2;
        Exit;
      end;
    end;

  finally
    BN_LFree (V_ROOT);
    BN_LFree (V_rem);
    BN_LFree (V_x0);
    BN_LFree (V_y);
    BN_LFree (V_y_k);
    BN_LFree (V);
    BN_LFree (U);
  end;
end;

// [+] 1.2.1
{
     
  SQUare FOrm Factorization, D. Shanks

  n > 0
}
function BN_Factor_SQUFOF (var p, q: T_BNX; const n: T_BNX;
  ABreak: PBoolean = nil): Integer;
var
  I_UU   : Integer;
  I_P0   : Integer;
  I_P1   : Integer;
  I_PP   : Integer;
  I_Q0   : Integer;
  I_Q1   : Integer;
  I_QQ   : Integer;
  I_R0   : Integer;
  I_R1   : Integer;
  I_RR   : Integer;

  procedure rotate_vars_();
  begin
    I_UU := I_P0;
    I_P0 := I_P1; // P0 = P1
    I_P1 := I_PP; // P1 = PP
    I_PP := I_UU; // PP = P0

    I_UU := I_Q0;
    I_Q0 := I_Q1; // Q0 = Q1
    I_Q1 := I_QQ; // Q1 = QQ
    I_QQ := I_UU; // QQ = Q0

    I_UU := I_R0;
    I_R0 := I_R1; // R0 = R1
    I_R1 := I_RR; // R1 = RR
    I_RR := I_UU; // RQ = R0
  end;

var
  V_n    : T_BNX;
  V_SQRT : T_BNX;
  V_rem  : T_BNX;
  V_nn   : array [0..8] of T_BNX;
  D      : T_BNX;
  U      : T_BNX;
  V      : T_BNX;

  function main_proc_(A_Factor: UIntX; var A_nF: Boolean): Integer;
  var
    V_mod  : UIntX;
    K_even : Boolean;
  begin
    Result := 0;

    A_nF := false;
    if BN_mod_2n (n, 2) = 1 then begin // n mod 4 = n mod 2^2 = 1
      A_nF := true;
      BN_mul_int (V_n, n, 1, A_Factor);
    end else begin
      A_Factor := 1;
      BN_copy (V_n, n);
    end;

    BN_sqrt_rem (V_SQRT, V_rem, V_n);

    I_P0 := 0;
    I_P1 := 1;
    I_PP := 2;
    I_Q0 := 3;
    I_Q1 := 4;
    I_QQ := 5;
    I_R0 := 6;
    I_R1 := 7;
    I_RR := 8;

    // P0 = 0
    BN_AssignZero (V_nn[I_P0]);
    // Q0 = 1
    BN_AssignPOne (V_nn[I_Q0]);
    // R0 = SQRT(n)
    BN_copy (V_nn[I_R0], V_SQRT);

    // P1 = SQRT(n)
    BN_copy (V_nn[I_P1], V_SQRT);
    // Q1 = n - R0^2
    BN_sqr (U, V_nn[I_R0]);
    BN_sub (V_nn[I_Q1], V_n, U);
    // R1 = 2*R0 div Q1
    BN_shl_1 (U, V_nn[I_R0]);
    BN_div (V_nn[I_R1], U, V_nn[I_Q1]);

    K_even := true; // k = 2,3,...
    while true do begin
      if Break_(ABreak) then Exit;

      // P(k) = R(k-1)*Q(k-1) - P(k-1)
      BN_mul (U, V_nn[I_R1], V_nn[I_Q1]);
      BN_sub (V_nn[I_PP], U, V_nn[I_P1]);
      // Q(k) = Q(k-2) + (P(k-1) - P(k))*R(k-1)
      BN_sub (U, V_nn[I_P1], V_nn[I_PP]);
      BN_mul (V, U, V_nn[I_R1]);
      BN_add (V_nn[I_QQ], V_nn[I_Q0], V);
      // R(k) = (P(k) + SQRT(n)) div Q(k)
      BN_add (U, V_nn[I_PP], V_SQRT);
      BN_div (V_nn[I_RR], U, V_nn[I_QQ]);

      if K_even then begin
        if BN_ppsqr (V_nn[I_QQ]) then begin
          BN_sqrt_rem (D, U, V_nn[I_QQ]);
          if BN_IsZero (U) then begin
            // P0 = -P(k)
            BN_ncopy (V_nn[I_P0], V_nn[I_PP]);
            // Q0 = D
            BN_copy (V_nn[I_Q0], D);
            // R0 = (P0 + SQRT(n)) div Q0
            BN_add (U, V_nn[I_P0], V_SQRT);
            BN_div (V_nn[I_R0], U, V_nn[I_Q0]);

            // P1 = R0*Q0 - P0
            BN_mul (U, V_nn[I_R0], V_nn[I_Q0]);
            BN_sub (V_nn[I_P1], U, V_nn[I_P0]);
            // Q1 = (n - P1^2) div Q0
            BN_sqr (U, V_nn[I_P1]);
            BN_sub (V, V_n, U);
            BN_div (V_nn[I_Q1], V, V_nn[I_Q0]);
            // R1 = (P1 + SQRT(n)) div Q1
            BN_add (U, V_nn[I_P1], V_SQRT);
            BN_div (V_nn[I_R1], U, V_nn[I_Q1]);

            Break;
          end;
        end;
      end;

      rotate_vars_();
      K_even := not K_even;
    end;

    while true do begin
      if Break_(ABreak) then Exit;

      // P(j) = R(j-1)*Q(j-1) - P(j-1)
      BN_mul (U, V_nn[I_R1], V_nn[I_Q1]);
      BN_sub (V_nn[I_PP], U, V_nn[I_P1]);
      // Q(j) = Q(j-2) + (P(j-1) - P(j))*R(j-1)
      BN_sub (U, V_nn[I_P1], V_nn[I_PP]);
      BN_mul (V, U, V_nn[I_R1]);
      BN_add (V_nn[I_QQ], V, V_nn[I_Q0]);
      // R(j) = (P(j) + SQRT(n)) div Q(j)
      BN_add (U, V_nn[I_PP], V_SQRT);
      BN_div (V_nn[I_RR], U, V_nn[I_QQ]);

      if BN_Compare (V_nn[I_PP], V_nn[I_P1]) = 0 then begin // P(j) = P(j-1)
        if BN_IsOne (V_nn[I_Q1]) then begin
          BN_AssignPOne (p); // p = 1
          BN_copy (q, n);    // q = n
          Result := -1;
        end else begin
          V_mod := BN_div_mod_int (D, V_nn[I_Q1], 1, A_Factor);
          if V_mod = 0 then begin
            BN_copy (p, D);          // p = Q(j-1) div Factor
          end else begin
            BN_copy (p, V_nn[I_Q1]); // p = Q(j-1)
          end;
          BN_div (q, n, p);          // q = n div p
          Result := 1;
        end;

        Break;
      end;

      rotate_vars_();
    end;
  end;

var
  B_nF : Boolean;
begin
  Result := 0;

  if BN_LE_Zero (n) then begin
    BN_AssignZero (p); // p = 0
    BN_AssignZero (q); // q = 0
    Exit;
  end;

  if BN_DataCompare (n, 3) <= 0 then begin // |n| <= 3
    BN_AssignPOne (p); // p = 1
    BN_copy (q, n);    // q = n
    Result := 1;
    Exit;
  end;

  try
    if BN_ppsqr (n) then begin
      BN_sqrt_rem (V_SQRT, V_rem, n);
      if BN_IsZero (V_rem) then begin // n is perfect square
        BN_copy (p, V_SQRT); // p = SQRT(n)
        BN_copy (q, V_SQRT); // q = SQRT(n)
        Result := 2;
        Exit;
      end;
    end;

    Result := main_proc_(2, B_nF); // Factor = 2
    if Result > 0 then Exit;
    if not B_nF then Exit;

    Result := main_proc_(3, B_nF); // Factor = 3
  finally
    BN_LFree (V_n);
    BN_LFree (V_SQRT);
    BN_LFree (V_rem);
    BN_LFree (V_nn[0]);
    BN_LFree (V_nn[1]);
    BN_LFree (V_nn[2]);
    BN_LFree (V_nn[3]);
    BN_LFree (V_nn[4]);
    BN_LFree (V_nn[5]);
    BN_LFree (V_nn[6]);
    BN_LFree (V_nn[7]);
    BN_LFree (V_nn[8]);
    BN_LFree (D);
    BN_LFree (U);
    BN_LFree (V);
  end;
end;

end.

